## iddawc 0.9.6

=== CMakeLists.txt ===
#
# Iddawc library
#
# CMake file used to build all programs
#
# Copyright 2018 Silvio Clecio <silvioprog@gmail.com>
# Copyright 2019-20 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the MIT License
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#

cmake_minimum_required(VERSION 3.5)

project(iddawc C)

set(CMAKE_C_STANDARD 99)
if (NOT MSVC)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Werror")
endif()

# library info

set(PROJECT_DESCRIPTION "Handle the flow of OAuth2 and OpenID Connect authentication process from the client side")
set(PROJECT_HOMEPAGE_URL "https://github.com/babelouest/iddawc/")
set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/iddawc/issues")
set(LIBRARY_VERSION_MAJOR "0")
set(LIBRARY_VERSION_MINOR "9")
set(LIBRARY_VERSION_PATCH "6")
set(ORCANIA_VERSION_REQUIRED "2.1.1")
set(YDER_VERSION_REQUIRED "1.4.11")
set(ULFIUS_VERSION_REQUIRED "2.6.8")
set(RHONABWY_VERSION_REQUIRED "0.9.12")

set(PROJECT_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
set(PROJECT_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})
set(PROJECT_VERSION_MINOR ${LIBRARY_VERSION_MINOR})
set(PROJECT_VERSION_PATCH ${LIBRARY_VERSION_PATCH})

if (${LIBRARY_VERSION_MAJOR} VERSION_LESS 10)
    set (LIBRARY_VERSION_MAJOR_PAD "0${LIBRARY_VERSION_MAJOR}")
else ()
    set (LIBRARY_VERSION_MAJOR_PAD "${LIBRARY_VERSION_MAJOR}")
endif ()
if (${LIBRARY_VERSION_MINOR} VERSION_LESS 10)
    set (LIBRARY_VERSION_MINOR_PAD "0${LIBRARY_VERSION_MINOR}")
else ()
    set (LIBRARY_VERSION_MINOR_PAD "${LIBRARY_VERSION_MINOR}")
endif ()
if (${LIBRARY_VERSION_PATCH} VERSION_LESS 10)
    set (LIBRARY_VERSION_PATCH_PAD "0${LIBRARY_VERSION_PATCH}")
else ()
    set (LIBRARY_VERSION_PATCH_PAD "${LIBRARY_VERSION_PATCH}")
endif ()
set(PROJECT_VERSION_NUMBER "${LIBRARY_VERSION_MAJOR_PAD}${LIBRARY_VERSION_MINOR_PAD}${LIBRARY_VERSION_PATCH_PAD}")

set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
set(LIBRARY_SOVERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}")

# cmake modules

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake-modules)

include(GNUInstallDirs)
include(CheckSymbolExists)

# check if _GNU_SOURCE is available

if (NOT _GNU_SOURCE)
    check_symbol_exists(__GNU_LIBRARY__ "features.h" _GNU_SOURCE)

    if (NOT _GNU_SOURCE)
        unset(_GNU_SOURCE CACHE)
        check_symbol_exists(_GNU_SOURCE "features.h" _GNU_SOURCE)
    endif ()
endif ()

if (_GNU_SOURCE)
    add_definitions(-D_GNU_SOURCE)
endif ()

# directories and source

set(INC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include)
set(SRC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src)

include_directories(${INC_DIR})

set(LIB_SRC
        ${INC_DIR}/iddawc.h # allow many IDEs to find and edit it
        ${SRC_DIR}/iddawc.c)

set(PKGCONF_REQ "")
set(PKGCONF_REQ_PRIVATE "")

# static library

option(BUILD_STATIC "Build static library." OFF)

if (BUILD_STATIC)
    add_library(iddawc_static STATIC ${LIB_SRC})
    target_compile_definitions(iddawc_static PUBLIC -DO_STATIC_LIBRARY)
    set_target_properties(iddawc_static PROPERTIES
            OUTPUT_NAME iddawc)
endif ()

# shared library

add_library(iddawc SHARED ${LIB_SRC})
set_target_properties(iddawc PROPERTIES
        COMPILE_OPTIONS -Wextra
        PUBLIC_HEADER "${INC_DIR}/iddawc.h;${PROJECT_BINARY_DIR}/iddawc-cfg.h"
        VERSION "${LIBRARY_VERSION}"
        SOVERSION "${LIBRARY_SOVERSION}")
target_link_libraries(iddawc ${LIBS})

include(FindJansson)
set(JANSSON_MIN_VERSION 2.11)
find_package(Jansson ${JANSSON_MIN_VERSION} REQUIRED)
if (JANSSON_FOUND)
	set(LIBS ${LIBS} ${JANSSON_LIBRARIES})
	include_directories(${JANSSON_INCLUDE_DIRS})
endif ()

include(FindGnuTLS)
find_package(GnuTLS REQUIRED)
if (GNUTLS_FOUND)
	set(LIBS ${LIBS} ${GNUTLS_LIBRARIES})
	include_directories(${GNUTLS_INCLUDE_DIRS})
endif ()

include(FindNettle)
find_package(Nettle REQUIRED)
if (NETTLE_FOUND)
	set(LIBS ${LIBS} ${NETTLE_LIBRARIES})
	include_directories(${NETTLE_INCLUDE_DIRS})
endif ()

include(FindMHD)
find_package(MHD REQUIRED)

set(SEARCH_ORCANIA OFF CACHE BOOL "Force to false") # Avoid to search and download orcania
set(SEARCH_ORCANIA_U OFF CACHE BOOL "Force to false") # Avoid to search and download orcania
set(SEARCH_YDER OFF CACHE BOOL "Force to false") # Avoid to search and download yder during
set(SEARCH_ORCANIA_R OFF CACHE BOOL "Force to false") # Avoid to search and download orcania during
set(SEARCH_YDER_R OFF CACHE BOOL "Force to false") # Avoid to search and download yder during
set(SEARCH_ULFIUS_R OFF CACHE BOOL "Force to false") # Avoid to search and download ulfius during

option(SEARCH_ORCANIA_I "Search for ORCANIA library" ON)
if (SEARCH_ORCANIA_I)
    set(Orcania_FIND_QUIETLY ON) # force to find Orcania quietly
    include(FindOrcania)
    find_package(Orcania ${ORCANIA_VERSION_REQUIRED} QUIET) # try to find orcania
    if (NOT ORCANIA_FOUND)
        include(DownloadProject)
        message(STATUS "Download Orcania ${ORCANIA_VERSION_REQUIRED}")
        download_project(PROJ orcania # ... otherwise, download archive
                URL "https://github.com/babelouest/orcania/archive/v${ORCANIA_VERSION_REQUIRED}.tar.gz"
                QUIET)
        add_subdirectory(${orcania_SOURCE_DIR} ${orcania_BINARY_DIR})
        include_directories(${orcania_SOURCE_DIR}/include)
        add_dependencies(iddawc orcania)
        set(ORCANIA_LIBRARIES orcania)
        include_directories(${orcania_BINARY_DIR})
    endif ()
endif ()
target_link_libraries(iddawc ${ORCANIA_LIBRARIES})
set(LIBS ${LIBS} ${ORCANIA_LIBRARIES})

option(SEARCH_YDER_I "Search for Yder library" ON)
if (SEARCH_YDER_I)
    set(Yder_FIND_QUIETLY ON) # force to find Yder quietly
    include(FindYder)
    find_package(Yder ${YDER_VERSION_REQUIRED} QUIET) # try to find Yder
    if (NOT YDER_FOUND)
        include(DownloadProject)
        message(STATUS "Download Yder ${YDER_VERSION_REQUIRED}")
        option(CHECK_ORCANIA "specific param" off)
        download_project(PROJ yder # ... otherwise, download archive
                URL "https://github.com/babelouest/yder/archive/v${YDER_VERSION_REQUIRED}.tar.gz"
                QUIET)
        add_subdirectory(${yder_SOURCE_DIR} ${yder_BINARY_DIR})
        include_directories(${yder_SOURCE_DIR}/include)
        include_directories(${orcania_SOURCE_DIR}/include)
        add_dependencies(iddawc yder)
        set(YDER_LIBRARIES yder)
        include_directories(${yder_BINARY_DIR})
    endif ()
endif ()
target_link_libraries(iddawc ${YDER_LIBRARIES})
set(LIBS ${LIBS} ${YDER_LIBRARIES})

option(SEARCH_ULFIUS_I "Search for Ulfius library" ON)
if (SEARCH_ULFIUS_I)
    set(Ulfius_FIND_QUIETLY ON)
    include(FindUlfius)
    find_package(Ulfius ${ULFIUS_VERSION_REQUIRED} QUIET)
    if (NOT ULFIUS_FOUND)
        include(DownloadProject)
        option(CHECK_ORCANIA "specific param" off)
        option(CHECK_YDER "specific param" off)
        message(STATUS "Download Ulfius ${ULFIUS_VERSION_REQUIRED}")
        download_project(PROJ ulfius
                URL "https://github.com/babelouest/ulfius/archive/v${ULFIUS_VERSION_REQUIRED}.tar.gz"
                QUIET)
        add_subdirectory(${ulfius_SOURCE_DIR} ${ulfius_BINARY_DIR})
        include_directories(${yder_SOURCE_DIR}/include)
        include_directories(${orcania_SOURCE_DIR}/include)
        include_directories(${ulfius_SOURCE_DIR}/include)
        add_dependencies(iddawc ulfius)
        set(ULFIUS_LIBRARIES ulfius)
        include_directories(${ulfius_BINARY_DIR})
    endif ()
endif ()
target_link_libraries(iddawc ${ULFIUS_LIBRARIES})
set(LIBS ${LIBS} ${ULFIUS_LIBRARIES})

option(SEARCH_RHONABWY_I "Search for Rhonabwy library" ON)
if (SEARCH_RHONABWY_I)
    set(Rhonabwy_FIND_QUIETLY ON)
    include(FindRhonabwy)
    find_package(Rhonabwy ${RHONABWY_VERSION_REQUIRED} QUIET)
    if (NOT RHONABWY_FOUND)
        include(DownloadProject)
        option(CHECK_ORCANIA "specific param" off)
        option(CHECK_YDER "specific param" off)
        option(CHECK_ULFIUS "specific param" off)
        message(STATUS "Download Rhonabwy ${RHONABWY_VERSION_REQUIRED}")
        download_project(PROJ rhonabwy
                URL "https://github.com/babelouest/rhonabwy/archive/v${RHONABWY_VERSION_REQUIRED}.tar.gz"
                QUIET)
        add_subdirectory(${rhonabwy_SOURCE_DIR} ${rhonabwy_BINARY_DIR})
        include_directories(${yder_SOURCE_DIR}/include)
        include_directories(${orcania_SOURCE_DIR}/include)
        include_directories(${ulfius_SOURCE_DIR}/include)
        include_directories(${rhonabwy_SOURCE_DIR}/include)
        add_dependencies(iddawc rhonabwy)
        set(RHONABWY_LIBRARIES rhonabwy)
        include_directories(${rhonabwy_BINARY_DIR})
    endif ()
endif ()
target_link_libraries(iddawc ${RHONABWY_LIBRARIES})
set(LIBS ${LIBS} ${RHONABWY_LIBRARIES})

# documentation

option(BUILD_IDDAWC_DOCUMENTATION "Build the documentation." OFF)
if (BUILD_IDDAWC_DOCUMENTATION)
    find_package(Doxygen)
    if (DOXYGEN_FOUND)
        set(doxyfile_in ${CMAKE_CURRENT_SOURCE_DIR}/doc/doxygen.cfg)
        set(doxyfile ${CMAKE_CURRENT_BINARY_DIR}/doxyfile)
        
        configure_file(${doxyfile_in} ${doxyfile} @ONLY)
        
        add_custom_target(doc
                          COMMAND ${DOXYGEN_EXECUTABLE} ${doxyfile_in}
                          WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                          COMMENT "Generating documentation with Doxygen"
                          VERBATIM)

    else ()
        message(FATAL_ERROR "Doxygen is needed to build the documentation.")
    endif ()
endif ()

# build iddawc-cfg.h file
configure_file(${INC_DIR}/iddawc-cfg.h.in ${PROJECT_BINARY_DIR}/iddawc-cfg.h)
set (CMAKE_EXTRA_INCLUDE_FILES ${PROJECT_BINARY_DIR})
include_directories(${PROJECT_BINARY_DIR})

# tests

option(BUILD_IDDAWC_TESTING "Build the testing tree." OFF) # because we do not use include(CTest)

if (BUILD_IDDAWC_TESTING)
    include(FindCheck)
    find_package(Check REQUIRED)
    if (CHECK_FOUND)
		include(FindSubunit)
		find_package(Subunit REQUIRED)
        find_package(Threads REQUIRED)

        enable_testing()

        set(CMAKE_CTEST_COMMAND ctest -V)

        set(TST_DIR ${CMAKE_CURRENT_SOURCE_DIR}/test)
        set(LIBS iddawc ${LIBS} ${CHECK_LIBRARIES} ${SUBUNIT_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} "-lm -lrt")

        set(TESTS
            core
            implicit
            id_token
            token
            load_config
            load_userinfo
            flow
            introspection
            revocation
            registration
            )

        configure_file(
                "${CMAKE_MODULE_PATH}/CTestCustom.cmake.in"
                "${CMAKE_CURRENT_BINARY_DIR}/CTestCustom.cmake"
                @ONLY)

        foreach (t ${TESTS})
            add_executable(${t} EXCLUDE_FROM_ALL ${TST_DIR}/${t}.c)
            target_include_directories(${t} PUBLIC ${TST_DIR})
            target_link_libraries(${t} PUBLIC ${LIBS})
            add_test(NAME ${t}
                    WORKING_DIRECTORY ${TST_DIR}
                    COMMAND ${t})
        endforeach ()
    endif ()
endif ()

# install target

option(INSTALL_HEADER "Install the header files" ON) # Install iddawc.h or not

configure_file(libiddawc.pc.in libiddawc.pc @ONLY)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libiddawc.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

set(TARGETS iddawc)

if (INSTALL_HEADER)
    install(TARGETS ${TARGETS}
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
            PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
else ()
    install(TARGETS ${TARGETS}

=== src/Makefile ===
#
# Iddawc Library
#
# Makefile used to build the software
#
# Copyright 2019-2020 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation;
# version 2.1 of the License.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this library.	If not, see <http://www.gnu.org/licenses/>.
#
PROJECT_NAME=iddawc
PROJECT_DESCRIPTION=OAuth2 client library
PROJECT_BUGREPORT_PATH=https://github.com/babelouest/iddawc/issues
PKGCONF_REQ=
PKGCONF_REQ_PRIVATE=
IDDAWC_INCLUDE=../include
PKGCONFIG_FILE=../libiddawc.pc
PKGCONFIG_TEMPLATE=../libiddawc.pc.in
CONFIG_FILE=$(IDDAWC_INCLUDE)/iddawc-cfg.h
CONFIG_TEMPLATE=$(IDDAWC_INCLUDE)/iddawc-cfg.h.in
DESTDIR=/usr/local
CC=gcc
CFLAGS+=-c -pedantic -std=gnu99 -fPIC -Wall -Werror -Wextra -D_REENTRANT -I$(IDDAWC_INCLUDE) $(ADDITIONALFLAGS) $(CPPFLAGS)
LIBS=-L$(DESTDIR)/lib -lc -lulfius -lorcania -lrhonabwy -lgnutls $(LDFLAGS)
SONAME=-soname
OBJECTS=iddawc.o
OUTPUT=libiddawc.so
VERSION_MAJOR=0
VERSION_MINOR=9
VERSION_PATCH=6

.PHONY: all clean

all: release

$(CONFIG_FILE):
	@cp $(CONFIG_TEMPLATE) $(CONFIG_FILE)
	@echo Config file $(CONFIG_FILE) generated
	@sed -i -e 's/$${PROJECT_VERSION}/$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH)/g' $(CONFIG_FILE)        
	@sed -i -e 's/$${PROJECT_VERSION_MAJOR}/$(VERSION_MAJOR)/g' $(CONFIG_FILE)        
	@sed -i -e 's/$${PROJECT_VERSION_MINOR}/$(VERSION_MINOR)/g' $(CONFIG_FILE)        
	@sed -i -e 's/$${PROJECT_VERSION_PATCH}/$(VERSION_PATCH)/g' $(CONFIG_FILE)        
	@sed -i -e 's/$${PROJECT_VERSION_NUMBER}/$(shell printf '%02d' $(VERSION_MAJOR))$(shell printf '%02d' $(VERSION_MINOR))$(shell printf '%02d' $(VERSION_PATCH))/g' $(CONFIG_FILE)        

$(PKGCONFIG_FILE):
	@cp $(PKGCONFIG_TEMPLATE) $(PKGCONFIG_FILE)
	@echo Pkgconfig file $(PKGCONFIG_FILE) generated
	@sed -i -e 's#@CMAKE_INSTALL_PREFIX@#$(DESTDIR)#g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@CMAKE_INSTALL_LIBDIR@/lib/g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@CMAKE_INSTALL_INCLUDEDIR@/include/g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@PROJECT_NAME@/$(PROJECT_NAME)/g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@PROJECT_DESCRIPTION@/$(PROJECT_DESCRIPTION)/g' $(PKGCONFIG_FILE)
	@sed -i -e 's|@PROJECT_BUGREPORT_PATH@|$(PROJECT_BUGREPORT_PATH)|g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@LIBRARY_VERSION@/$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH)/g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@PKGCONF_REQ@/$(PKGCONF_REQ)/g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@PKGCONF_REQ_PRIVATE@/$(PKGCONF_REQ_PRIVATE)/g' $(PKGCONFIG_FILE)

target: $(OBJECTS)

%.o: %.c $(CONFIG_FILE) $(IDDAWC_INCLUDE)/iddawc.h
	$(CC) $(CFLAGS) $<

libiddawc.so: $(CONFIG_FILE) $(OBJECTS)
	$(CC) -shared -fPIC -Wl,$(SONAME),$(OUTPUT) -o $(OUTPUT).$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH) $(OBJECTS) $(LIBS) $(LYDER) $(LJANSSON) $(LCURL) $(LGNUTLS)
	ln -sf $(OUTPUT).$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH) $(OUTPUT)

clean:
	rm -f *.o *.so *.a $(OUTPUT) $(OUTPUT).* $(CONFIG_FILE) $(PKGCONFIG_FILE) $(CONFIG_FILE)

install: all $(PKGCONFIG_FILE)
	install $(OUTPUT).$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH) $(DESTDIR)/lib
	mkdir -p $(DESTDIR)/lib/pkgconfig/
	install -m644 $(PKGCONFIG_FILE) $(DESTDIR)/lib/pkgconfig/
	install -m644 $(IDDAWC_INCLUDE)/iddawc.h $(DESTDIR)/include
	install -m644 $(CONFIG_FILE) $(DESTDIR)/include
	-ldconfig $(DESTDIR)/lib

uninstall:
	rm -f $(DESTDIR)/lib/$(OUTPUT) $(DESTDIR)/lib/libiddawc.a
	rm -f $(DESTDIR)/lib/$(OUTPUT).*
	rm -f $(DESTDIR)/include/iddawc.h
	rm -f $(DESTDIR)/include/$(CONFIG_FILE)
	rm -f $(DESTDIR)/lib/pkgconfig/$(PKGCONFIG_FILE)

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

debug: libiddawc.so

release: ADDITIONALFLAGS=-O3

release: libiddawc.so

=== test/Makefile ===
#
# Iddawc library
#
# Makefile used to build the tests
#
# Public domain, no copyright. Use at your own risk.
#

IDDAWC_INCLUDE=../include
IDDAWC_LOCATION=../src
IDDAWC_LIBRARY=$(IDDAWC_LOCATION)/libiddawc.so
CC=gcc
CFLAGS+=-Wall -D_REENTRANT -I$(IDDAWC_INCLUDE) -DDEBUG -g -O0 $(CPPFLAGS)
LDFLAGS=-lc -lorcania -lulfius -liddawc -lrhonabwy -ljansson -L$(IDDAWC_LOCATION) -lyder $(shell pkg-config --libs check)
VALGRIND_COMMAND=valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all
TARGET=core implicit id_token token load_config load_userinfo flow introspection revocation registration
TARGET_TEST=test_core test_implicit test_id_token test_token test_load_config test_load_userinfo test_flow test_introspection test_revocation test_registration
MEMCHECK=0

all: test

clean:
	rm -f *.o $(TARGET) valgrind-*.txt

$(IDDAWC_LIBRARY): $(IDDAWC_INCLUDE)/iddawc.h $(IDDAWC_LOCATION)/iddawc.c
	cd $(IDDAWC_LOCATION) && $(MAKE) debug

%: $(IDDAWC_LIBRARY) %.c
	$(CC) $(CFLAGS) $^ -o $@ $(LDFLAGS)

test_%: %
	@if [ "$(MEMCHECK)" = "0" ]; then \
	  LD_LIBRARY_PATH=$(IDDAWC_LOCATION):$(LD_LIBRARY_PATH) ./$^ ; \
	else \
	  CK_FORK=no LD_LIBRARY_PATH=$(IDDAWC_LOCATION):$(LD_LIBRARY_PATH) $(VALGRIND_COMMAND) ./$^ 2>valgrind-$@.txt; \
	fi

test: $(TARGET) $(TARGET_TEST)

check: test

=== debian/changelog ===
iddawc (0.9.6-2) unstable; urgency=medium

  * New upload to increase urgency to medium

 -- Nicolas Mora <babelouest@debian.org>  Mon, 20 Jul 2020 07:02:43 -0400

iddawc (0.9.6-1) unstable; urgency=low

  * New upstream release
  * d/rules: avoid downloading dependencies if not found
  * d/rules: display ctest error on failure
  * d/control: Remove dh-exec from builddep

 -- Nicolas Mora <babelouest@debian.org>  Sun, 19 Jul 2020 08:24:55 -0400

iddawc (0.9.5-2) unstable; urgency=low

  * Upload to unstable
  * Set upstream metadata fields
  * Fix aotopkgtest

 -- Nicolas Mora <nicolas@babelouest.org>  Mon, 29 Jun 2020 07:04:27 -0400

iddawc (0.9.5-1) experimental; urgency=low

  * Initial release. Closes: #962279

 -- Nicolas Mora <nicolas@babelouest.org>  Wed, 03 Jun 2020 13:37:03 -0400

=== debian/control ===
Source: iddawc
Section: devel
Priority: optional
Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
Uploaders: Nicolas Mora <babelouest@debian.org>
Build-Depends: debhelper-compat (= 13)
             , liborcania-dev
             , libyder-dev
             , libulfius-dev
             , librhonabwy-dev
             , libgnutls28-dev
             , zlib1g-dev
             , cmake
             , pkg-config
             , check
             , doxygen
Standards-Version: 4.5.0
Homepage: https://github.com/babelouest/iddawc
Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/iddawc
Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/iddawc.git
Rules-Requires-Root: no

Package: libiddawc0.9
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: OAuth2 and OIDC client library
 Handles the OAuth2 and OpenID Connect authentication process flow from the
 client side.
 .
  - Generates requests based on input parameters
  - Parses response
  - Validates response values

Package: libiddawc-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libiddawc0.9 (= ${binary:Version}), ${misc:Depends}
Description: OAuth2 and OIDC client library - development
 Handles the OAuth2 and OpenID Connect authentication process flow from the
 client side.
 .
  - Generates requests based on input parameters
  - Parses response
  - Validates response values
 .
 This package contains the development files.

## iddawc 0.9.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -30,11 +30,11 @@
 set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/iddawc/issues")
 set(LIBRARY_VERSION_MAJOR "0")
 set(LIBRARY_VERSION_MINOR "9")
-set(LIBRARY_VERSION_PATCH "6")
+set(LIBRARY_VERSION_PATCH "8")
 set(ORCANIA_VERSION_REQUIRED "2.1.1")
-set(YDER_VERSION_REQUIRED "1.4.11")
-set(ULFIUS_VERSION_REQUIRED "2.6.8")
-set(RHONABWY_VERSION_REQUIRED "0.9.12")
+set(YDER_VERSION_REQUIRED "1.4.12")
+set(ULFIUS_VERSION_REQUIRED "2.7.1")
+set(RHONABWY_VERSION_REQUIRED "0.9.13")
 
 set(PROJECT_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
 set(PROJECT_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})
@@ -116,7 +116,6 @@
         PUBLIC_HEADER "${INC_DIR}/iddawc.h;${PROJECT_BINARY_DIR}/iddawc-cfg.h"
         VERSION "${LIBRARY_VERSION}"
         SOVERSION "${LIBRARY_SOVERSION}")
-target_link_libraries(iddawc ${LIBS})
 
 include(FindJansson)
 set(JANSSON_MIN_VERSION 2.11)
@@ -139,6 +138,7 @@
 	set(LIBS ${LIBS} ${NETTLE_LIBRARIES})
 	include_directories(${NETTLE_INCLUDE_DIRS})
 endif ()
+target_link_libraries(iddawc ${LIBS})
 
 include(FindMHD)
 find_package(MHD REQUIRED)
@@ -303,6 +303,10 @@
             introspection
             revocation
             registration
+            dpop
+            api_request
+            device
+            par
             )
 
         configure_file(
@@ -339,4 +343,3 @@
             ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
             PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
 else ()
-    install(TARGETS ${TARGETS}

=== Makefile ===
#
# Iddawc library
#
# Makefile used to build all programs
#
# Copyright 2020 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation;
# version 2.1 of the License.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this library.	If not, see <http://www.gnu.org/licenses/>.
#

LIBIDDAWC_LOCATION=./src
TESTS_LOCATION=./test

all:
	cd $(LIBIDDAWC_LOCATION) && $(MAKE) $*

debug:
	cd $(LIBIDDAWC_LOCATION) && $(MAKE) debug $*

clean:
	cd $(LIBIDDAWC_LOCATION) && $(MAKE) clean
	cd $(TESTS_LOCATION) && $(MAKE) clean

install:
	cd $(LIBIDDAWC_LOCATION) && $(MAKE) install

uninstall:
	cd $(LIBIDDAWC_LOCATION) && $(MAKE) uninstall

check:
	cd $(TESTS_LOCATION) && $(MAKE)

doxygen:
	doxygen doc/doxygen.cfg

=== examples/Makefile ===
#
# Iddawc library
#
# Makefile used to build the example files
#
# Copyright 2020 Nicolas Mora <mail@babelouest.org>
#
# License MIT
#

IDDAWC_INCLUDE=../include
IDDAWC_LOCATION=../src
IDDAWC_LIBRARY=$(IDDAWC_LOCATION)/libiddawc.so
CC=gcc
CFLAGS+=-Wall -D_REENTRANT -I$(IDDAWC_INCLUDE) -DDEBUG -g -O0 $(CPPFLAGS)
LDFLAGS=-lc -liddawc -ljansson -L$(IDDAWC_LOCATION) -lyder
TARGET=github_example gitlab_example glewlwyd_oidc_id_token_code google_example microsoft_example facebook_example

all: $(TARGET)

clean:
	rm -f *.o $(TARGET)

$(IDDAWC_LIBRARY): $(IDDAWC_INCLUDE)/iddawc.h $(IDDAWC_LOCATION)/iddawc.c
	cd $(IDDAWC_LOCATION) && $(MAKE) debug

%: $(IDDAWC_LIBRARY) %.c
	$(CC) $(CFLAGS) $^ -o $@ $(LDFLAGS)

run_%: %
	LD_LIBRARY_PATH=$(IDDAWC_LOCATION):$(LD_LIBRARY_PATH) ./$^

=== src/Makefile ===
--- 
+++ 
@@ -31,13 +31,13 @@
 DESTDIR=/usr/local
 CC=gcc
 CFLAGS+=-c -pedantic -std=gnu99 -fPIC -Wall -Werror -Wextra -D_REENTRANT -I$(IDDAWC_INCLUDE) $(ADDITIONALFLAGS) $(CPPFLAGS)
-LIBS=-L$(DESTDIR)/lib -lc -lulfius -lorcania -lrhonabwy -lgnutls $(LDFLAGS)
+LIBS=-L$(DESTDIR)/lib -lc -lulfius -lyder -lorcania -lrhonabwy -lgnutls -ljansson $(LDFLAGS)
 SONAME=-soname
 OBJECTS=iddawc.o
 OUTPUT=libiddawc.so
 VERSION_MAJOR=0
 VERSION_MINOR=9
-VERSION_PATCH=6
+VERSION_PATCH=8
 
 .PHONY: all clean
 
@@ -79,7 +79,7 @@
 
 install: all $(PKGCONFIG_FILE)
 	install $(OUTPUT).$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH) $(DESTDIR)/lib
-	mkdir -p $(DESTDIR)/lib/pkgconfig/
+	mkdir -p $(DESTDIR)/lib/pkgconfig/ $(DESTDIR)/include
 	install -m644 $(PKGCONFIG_FILE) $(DESTDIR)/lib/pkgconfig/
 	install -m644 $(IDDAWC_INCLUDE)/iddawc.h $(DESTDIR)/include
 	install -m644 $(CONFIG_FILE) $(DESTDIR)/include

=== test/Makefile ===
--- 
+++ 
@@ -13,8 +13,8 @@
 CFLAGS+=-Wall -D_REENTRANT -I$(IDDAWC_INCLUDE) -DDEBUG -g -O0 $(CPPFLAGS)
 LDFLAGS=-lc -lorcania -lulfius -liddawc -lrhonabwy -ljansson -L$(IDDAWC_LOCATION) -lyder $(shell pkg-config --libs check)
 VALGRIND_COMMAND=valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all
-TARGET=core implicit id_token token load_config load_userinfo flow introspection revocation registration
-TARGET_TEST=test_core test_implicit test_id_token test_token test_load_config test_load_userinfo test_flow test_introspection test_revocation test_registration
+TARGET=core implicit id_token token load_config load_userinfo flow introspection revocation registration dpop api_request device par
+TARGET_TEST=test_core test_implicit test_id_token test_token test_load_config test_load_userinfo test_flow test_introspection test_revocation test_registration test_dpop test_api_request test_device test_par
 MEMCHECK=0
 
 all: test

=== debian/changelog ===
iddawc (0.9.8-2) unstable; urgency=medium

  * Remove d/patches
  * restore d/tests removed by mistake

 -- Nicolas Mora <babelouest@debian.org>  Sun, 10 Jan 2021 17:35:06 -0500

iddawc (0.9.8-1) unstable; urgency=medium

  * New upstream release (Closes: #979402)
  * d/symbols: update symbols list
  * d/tests: add new tests

 -- Nicolas Mora <babelouest@debian.org>  Sat, 09 Jan 2021 13:50:55 -0500

iddawc (0.9.7-1) unstable; urgency=medium

  * d/symbols: update symbols
  * d/control: Update standards version to 4.5.1 (no change)
  * d/control: add libiddawc-dev dependendies

 -- Nicolas Mora <babelouest@debian.org>  Fri, 18 Dec 2020 07:20:44 -0500

=== debian/control ===
--- 
+++ 
@@ -9,12 +9,13 @@
              , libulfius-dev
              , librhonabwy-dev
              , libgnutls28-dev
+             , libjansson-dev
              , zlib1g-dev
              , cmake
              , pkg-config
              , check
              , doxygen
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: https://github.com/babelouest/iddawc
 Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/iddawc
 Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/iddawc.git
@@ -38,6 +39,13 @@
 Architecture: any
 Multi-Arch: same
 Depends: libiddawc0.9 (= ${binary:Version}), ${misc:Depends}
+       , liborcania-dev
+       , libyder-dev
+       , libulfius-dev
+       , librhonabwy-dev
+       , libgnutls28-dev
+       , libjansson-dev
+       , zlib1g-dev
 Description: OAuth2 and OIDC client library - development
  Handles the OAuth2 and OpenID Connect authentication process flow from the
  client side.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1
# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
#export CTEST_PARALLEL_LEVEL = 1
#export CK_FORK = no

export CTEST_OUTPUT_ON_FAILURE=1

%:
	dh $@  --buildsystem=cmake --builddirectory=build

override_dh_auto_configure:
	dh_auto_configure -- $(ARGS) \
	                    -DSKIP_BUILD_RPATH=TRUE \
	                    -DBUILD_IDDAWC_TESTING=ON \
	                    -DINSTALL_HEADER=ON \
	                    -DDOWNLOAD_DEPENDENCIES=OFF \
	                    --no-warn-unused-cli

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	cd build && $(MAKE) test -j1
endif

override_dh_auto_build:
	doxygen doc/doxygen.cfg
	dh_auto_build --

=== debian/tests/control ===
Tests: unit-test
Depends: @, gcc, libc-dev, libgnutls28-dev, libjansson-dev, libyder-dev, librhonabwy-dev, liborcania-dev, libulfius-dev, check, libsubunit-dev, pkg-config

## iddawc 1.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 # CMake file used to build all programs
 #
 # Copyright 2018 Silvio Clecio <silvioprog@gmail.com>
-# Copyright 2019-20 Nicolas Mora <mail@babelouest.org>
+# Copyright 2019-2021 Nicolas Mora <mail@babelouest.org>
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the MIT License
@@ -25,16 +25,16 @@
 
 # library info
 
-set(PROJECT_DESCRIPTION "Handle the flow of OAuth2 and OpenID Connect authentication process from the client side")
+set(PROJECT_DESCRIPTION "OAuth2/OIDC client library")
 set(PROJECT_HOMEPAGE_URL "https://github.com/babelouest/iddawc/")
 set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/iddawc/issues")
-set(LIBRARY_VERSION_MAJOR "0")
-set(LIBRARY_VERSION_MINOR "9")
-set(LIBRARY_VERSION_PATCH "8")
-set(ORCANIA_VERSION_REQUIRED "2.1.1")
-set(YDER_VERSION_REQUIRED "1.4.12")
-set(ULFIUS_VERSION_REQUIRED "2.7.1")
-set(RHONABWY_VERSION_REQUIRED "0.9.13")
+set(LIBRARY_VERSION_MAJOR "1")
+set(LIBRARY_VERSION_MINOR "1")
+set(LIBRARY_VERSION_PATCH "1")
+set(ORCANIA_VERSION_REQUIRED "2.2.1")
+set(YDER_VERSION_REQUIRED "1.4.14")
+set(ULFIUS_VERSION_REQUIRED "2.7.6")
+set(RHONABWY_VERSION_REQUIRED "1.1.2")
 
 set(PROJECT_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
 set(PROJECT_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})
@@ -64,6 +64,7 @@
 # cmake modules
 
 set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake-modules)
+set(IDWCC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/tools/idwcc)
 
 include(GNUInstallDirs)
 include(CheckSymbolExists)
@@ -125,18 +126,18 @@
 	include_directories(${JANSSON_INCLUDE_DIRS})
 endif ()
 
+include(FindNettle)
+find_package(Nettle REQUIRED)
+if (NETTLE_FOUND)
+	set(LIBS ${LIBS} ${NETTLE_LIBRARIES})
+	include_directories(${NETTLE_INCLUDE_DIRS})
+endif ()
+
 include(FindGnuTLS)
 find_package(GnuTLS REQUIRED)
 if (GNUTLS_FOUND)
 	set(LIBS ${LIBS} ${GNUTLS_LIBRARIES})
 	include_directories(${GNUTLS_INCLUDE_DIRS})
-endif ()
-
-include(FindNettle)
-find_package(Nettle REQUIRED)
-if (NETTLE_FOUND)
-	set(LIBS ${LIBS} ${NETTLE_LIBRARIES})
-	include_directories(${NETTLE_INCLUDE_DIRS})
 endif ()
 target_link_libraries(iddawc ${LIBS})
 
@@ -166,6 +167,8 @@
         add_dependencies(iddawc orcania)
         set(ORCANIA_LIBRARIES orcania)
         include_directories(${orcania_BINARY_DIR})
+    else ()
+        include_directories(${ORCANIA_INCLUDE_DIRS})
     endif ()
 endif ()
 target_link_libraries(iddawc ${ORCANIA_LIBRARIES})
@@ -189,6 +192,8 @@
         add_dependencies(iddawc yder)
         set(YDER_LIBRARIES yder)
         include_directories(${yder_BINARY_DIR})
+    else ()
+        include_directories(${YDER_INCLUDE_DIRS})
     endif ()
 endif ()
 target_link_libraries(iddawc ${YDER_LIBRARIES})
@@ -214,6 +219,8 @@
         add_dependencies(iddawc ulfius)
         set(ULFIUS_LIBRARIES ulfius)
         include_directories(${ulfius_BINARY_DIR})
+    else ()
+        include_directories(${ULFIUS_INCLUDE_DIRS})
     endif ()
 endif ()
 target_link_libraries(iddawc ${ULFIUS_LIBRARIES})
@@ -241,10 +248,34 @@
         add_dependencies(iddawc rhonabwy)
         set(RHONABWY_LIBRARIES rhonabwy)
         include_directories(${rhonabwy_BINARY_DIR})
+    else ()
+        include_directories(${RHONABWY_INCLUDE_DIRS})
     endif ()
 endif ()
 target_link_libraries(iddawc ${RHONABWY_LIBRARIES})
 set(LIBS ${LIBS} ${RHONABWY_LIBRARIES})
+
+# build idwcc
+
+option(BUILD_IDWCC "Build idwcc application." ON)
+
+if (BUILD_IDWCC)
+    find_package(Threads REQUIRED)
+    set(LIBS ${LIBS} ${CMAKE_THREAD_LIBS_INIT})
+    include(FindZLIB)
+    find_package(ZLIB REQUIRED)
+    if (ZLIB_FOUND)
+      set(LIBS ${LIBS} ${ZLIB_LIBRARIES})
+      include_directories(${ZLIB_INCLUDE_DIRS})
+    endif ()
+    add_executable(idwcc ${IDWCC_DIR}/idwcc.c ${INC_DIR}/iddawc.h ${IDWCC_DIR}/http_compression_callback.c ${IDWCC_DIR}/http_compression_callback.h ${IDWCC_DIR}/static_compressed_inmemory_website_callback.c ${IDWCC_DIR}/static_compressed_inmemory_website_callback.h ${PROJECT_BINARY_DIR}/iddawc-cfg.h)
+    set_target_properties(idwcc PROPERTIES SKIP_BUILD_RPATH TRUE)
+    add_dependencies(idwcc iddawc)
+    target_link_libraries(idwcc iddawc ${LIBS})
+    install(TARGETS idwcc RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
+    install(FILES ${IDWCC_DIR}/idwcc.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1 COMPONENT runtime)
+    install(DIRECTORY ${IDWCC_DIR}/webapp/ DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/idwcc/webapp/ COMPONENT runtime)
+endif ()
 
 # documentation
 
@@ -297,49 +328,3 @@
             implicit
             id_token
             token
-            load_config
-            load_userinfo
-            flow
-            introspection
-            revocation
-            registration
-            dpop
-            api_request
-            device
-            par
-            )
-
-        configure_file(
-                "${CMAKE_MODULE_PATH}/CTestCustom.cmake.in"
-                "${CMAKE_CURRENT_BINARY_DIR}/CTestCustom.cmake"
-                @ONLY)
-
-        foreach (t ${TESTS})
-            add_executable(${t} EXCLUDE_FROM_ALL ${TST_DIR}/${t}.c)
-            target_include_directories(${t} PUBLIC ${TST_DIR})
-            target_link_libraries(${t} PUBLIC ${LIBS})
-            add_test(NAME ${t}
-                    WORKING_DIRECTORY ${TST_DIR}
-                    COMMAND ${t})
-        endforeach ()
-    endif ()
-endif ()
-
-# install target
-
-option(INSTALL_HEADER "Install the header files" ON) # Install iddawc.h or not
-
-configure_file(libiddawc.pc.in libiddawc.pc @ONLY)
-
-install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libiddawc.pc
-        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
-
-set(TARGETS iddawc)
-
-if (INSTALL_HEADER)
-    install(TARGETS ${TARGETS}
-            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
-            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
-            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
-            PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
-else ()

=== Makefile ===
--- 
+++ 
@@ -20,23 +20,29 @@
 #
 
 LIBIDDAWC_LOCATION=./src
+IDWCC_LOCATION=./tools/idwcc
 TESTS_LOCATION=./test
 
 all:
 	cd $(LIBIDDAWC_LOCATION) && $(MAKE) $*
+	cd $(IDWCC_LOCATION) && $(MAKE) $*
 
 debug:
 	cd $(LIBIDDAWC_LOCATION) && $(MAKE) debug $*
 
 clean:
 	cd $(LIBIDDAWC_LOCATION) && $(MAKE) clean
+	cd $(IDWCC_LOCATION) && $(MAKE) clean
 	cd $(TESTS_LOCATION) && $(MAKE) clean
+	rm -rf doc/html $(TESTS_LOCATION)/cert/*.crt $(TESTS_LOCATION)/cert/*.key $(TESTS_LOCATION)/cert/*.log
 
 install:
 	cd $(LIBIDDAWC_LOCATION) && $(MAKE) install
+	cd $(IDWCC_LOCATION) && $(MAKE) install
 
 uninstall:
 	cd $(LIBIDDAWC_LOCATION) && $(MAKE) uninstall
+	cd $(IDWCC_LOCATION) && $(MAKE) uninstall
 
 check:
 	cd $(TESTS_LOCATION) && $(MAKE)

=== src/Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #
 # Makefile used to build the software
 #
-# Copyright 2019-2020 Nicolas Mora <mail@babelouest.org>
+# Copyright 2019-2021 Nicolas Mora <mail@babelouest.org>
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU Lesser General Public License
@@ -19,7 +19,7 @@
 # License along with this library.	If not, see <http://www.gnu.org/licenses/>.
 #
 PROJECT_NAME=iddawc
-PROJECT_DESCRIPTION=OAuth2 client library
+PROJECT_DESCRIPTION=OAuth2-OIDC client library
 PROJECT_BUGREPORT_PATH=https://github.com/babelouest/iddawc/issues
 PKGCONF_REQ=
 PKGCONF_REQ_PRIVATE=
@@ -35,9 +35,9 @@
 SONAME=-soname
 OBJECTS=iddawc.o
 OUTPUT=libiddawc.so
-VERSION_MAJOR=0
-VERSION_MINOR=9
-VERSION_PATCH=8
+VERSION_MAJOR=1
+VERSION_MINOR=1
+VERSION_PATCH=1
 
 .PHONY: all clean

=== test/Makefile ===
#
# Iddawc library
#
# Makefile used to build the tests
#
# Public domain, no copyright. Use at your own risk.
#

IDDAWC_INCLUDE=../include
IDDAWC_LOCATION=../src
IDDAWC_LIBRARY=$(IDDAWC_LOCATION)/libiddawc.so
CC=gcc
CFLAGS+=-Wall -D_REENTRANT -I$(IDDAWC_INCLUDE) -DDEBUG -g -O0 $(CPPFLAGS)
LDFLAGS=-lc $(shell pkg-config --libs liborcania) $(shell pkg-config --libs libyder) $(shell pkg-config --libs libulfius) $(shell pkg-config --libs librhonabwy) -liddawc -L$(IDDAWC_LOCATION) $(shell pkg-config --libs jansson) $(shell pkg-config --libs check) $(shell pkg-config --libs gnutls)
VALGRIND_COMMAND=valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all
TARGET=core implicit id_token token load_config load_userinfo flow introspection revocation registration dpop api_request device par ciba session
TARGET_TEST=test_core test_implicit test_id_token test_token test_load_config test_load_userinfo test_flow test_introspection test_revocation test_registration test_dpop test_api_request test_device test_par test_ciba test_session
VERBOSE=0
MEMCHECK=0

all: test

clean:
	rm -f *.o $(TARGET) valgrind-*.txt *.log

$(IDDAWC_LIBRARY): $(IDDAWC_INCLUDE)/iddawc.h $(IDDAWC_LOCATION)/iddawc.c
	cd $(IDDAWC_LOCATION) && $(MAKE) debug

%: $(IDDAWC_LIBRARY) %.c
	$(CC) $(CFLAGS) $^ -o $@ $(LDFLAGS)

test_%: % $(IDDAWC_LIBRARY)
	@if [ "$(VERBOSE)" = "0" ] && [ "$(MEMCHECK)" = "0" ]; then \
		LD_LIBRARY_PATH=$(IDDAWC_LOCATION):${LD_LIBRARY_PATH} ./run_test.sh ./$^; \
	elif [ "$(MEMCHECK)" = "0" ]; then \
		LD_LIBRARY_PATH=$(IDDAWC_LOCATION):${LD_LIBRARY_PATH} ./$^ ; \
	else \
		CK_FORK=no LD_LIBRARY_PATH=$(IDDAWC_LOCATION):${LD_LIBRARY_PATH} $(VALGRIND_COMMAND) ./$^ 2>valgrind-$@.txt; \
	fi

test: $(TARGET) $(TARGET_TEST)

check: test

=== tools/idwcc/Makefile ===
#
# idwcc: OAuth2/OIDC client program to test or validate OAuth2/OIDC AS
#
# Makefile used to build the software
#
# Copyright 2021 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU GENERAL PUBLIC LICENSE
# License as published by the Free Software Foundation;
# version 3 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
CC=gcc
IDDAWC_INCLUDE=../../include
IDDAWC_LOCATION=../../src
DESTDIR=/usr/local
IDDAWC_LIBRARY=../../src/libiddawc.so
IDDAWC_VERSION=$(shell curl -s https://api.github.com/repos/babelouest/iddawc/releases/latest | grep tag_name | cut -d '"' -f 4 | cut -c 2-)
ALPINE_VERSION=3.14.3

CFLAGS+=-c -Wall -I$(IDDAWC_INCLUDE) $(ADDITIONALFLAGS) $(CPPFLAGS) -DWEBAPP_PATH=\"$(DESTDIR)/share/idwcc/webapp/\"
LIBS=-lc -liddawc -L$(IDDAWC_LOCATION) $(shell pkg-config --libs liborcania) $(shell pkg-config --libs libyder) $(shell pkg-config --libs libulfius) $(shell pkg-config --libs jansson) -lpthread -lz
VALGRIND_COMMAND=valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all --track-origins=yes
OBJECTS=idwcc.o static_compressed_inmemory_website_callback.o http_compression_callback.o

all: idwcc

all: ADDITIONALFLAGS= -O3

clean:
	rm -f *.o idwcc
	rm -f iddawc-dev-full_*_alpine_*_x86_64.tar.gz
	docker rmi -f babelouest/idwcc:latest babelouest/idwcc:$(IDDAWC_VERSION)
	docker system prune -f

debug: idwcc

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

$(IDDAWC_LIBRARY): $(IDDAWC_INCLUDE)/iddawc.h $(IDDAWC_LOCATION)/iddawc.c
	cd $(IDDAWC_LOCATION) && $(MAKE) debug

%.o: %.c $(IDDAWC_LIBRARY) static_compressed_inmemory_website_callback.h static_compressed_inmemory_website_callback.c http_compression_callback.h http_compression_callback.c idwcc.c
	$(CC) $(CFLAGS) $(CPPFLAGS) $<

idwcc: $(OBJECTS)
	$(CC) -o $@ $^ $(LIBS) $(LDFLAGS)

install: idwcc
	mkdir -p $(DESTDIR)/bin $(DESTDIR)/man/man1/ $(DESTDIR)/share/idwcc/
	install -m755 idwcc $(DESTDIR)/bin
	install -m644 idwcc.1 $(DESTDIR)/man/man1/
	cp -R webapp/ $(DESTDIR)/share/idwcc/

uninstall:
	rm -f $(DESTDIR)/bin/idwcc $(DESTDIR)/man/man1/idwcc.1 $(DESTDIR)/share/idwcc/

test: idwcc
	LD_LIBRARY_PATH=$(IDDAWC_LOCATION): ./idwcc -w webapp

memcheck: debug
	LD_LIBRARY_PATH=$(IDDAWC_LOCATION): $(VALGRIND_COMMAND) ./idwcc -w webapp 2>valgrind.txt

manpage: idwcc
	help2man ./idwcc -s 1 -n "OAuth2/OIDC client program to test or validate OAuth2/OIDC AS." > idwcc.1

iddawc-dev-full_$(IDDAWC_VERSION)_alpine_$(ALPINE_VERSION)_x86_64.tar.gz:
	wget https://github.com/babelouest/iddawc/releases/download/v${IDDAWC_VERSION}/iddawc-dev-full_$(IDDAWC_VERSION)_alpine_$(ALPINE_VERSION)_x86_64.tar.gz

docker-build: iddawc-dev-full_$(IDDAWC_VERSION)_alpine_$(ALPINE_VERSION)_x86_64.tar.gz
	docker build -t babelouest/idwcc:$(IDDAWC_VERSION) --build-arg IDDAWC_VERSION=$(IDDAWC_VERSION) --build-arg ALPINE_VERSION=$(ALPINE_VERSION) .
	docker tag babelouest/idwcc:$(IDDAWC_VERSION) babelouest/idwcc:latest

docker-run:
	docker run -it --rm -p 4398:4398 babelouest/idwcc:latest

=== debian/changelog ===
iddawc (1.1.1-2) unstable; urgency=medium

  * d/patches add cmake patch to avoid downloading missing dependencies

 -- Nicolas Mora <babelouest@debian.org>  Sat, 20 Nov 2021 15:37:33 -0500

iddawc (1.1.1-1) unstable; urgency=medium

  * New upstream release
  * d/patches: remove uninit.patch

 -- Nicolas Mora <babelouest@debian.org>  Thu, 18 Nov 2021 22:51:31 -0500

iddawc (1.1.0-2) unstable; urgency=medium

  * d/patches: disable test_iddawc_code_pkce_flow
  * d/control: update idwcc description (Closes: #999801)

 -- Nicolas Mora <babelouest@debian.org>  Tue, 16 Nov 2021 19:44:37 -0500

iddawc (1.1.0-1) unstable; urgency=medium

  * New upstream release
  * d/control: new package name
  * d/control: Upgrade Standards-Version to 4.6.0 (No change)
  * d/patch: Add ununit.patch
  * d/symbols: Update symbols table
  * d/salsa-ci.yml: enable salsa CI

 -- Nicolas Mora <babelouest@debian.org>  Tue, 16 Nov 2021 08:15:27 -0500

=== debian/control ===
--- 
+++ 
@@ -15,17 +15,20 @@
              , pkg-config
              , check
              , doxygen
-Standards-Version: 4.5.1
+             , gnutls-bin
+Standards-Version: 4.6.0
 Homepage: https://github.com/babelouest/iddawc
 Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/iddawc
 Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/iddawc.git
 Rules-Requires-Root: no
 
-Package: libiddawc0.9
+Package: libiddawc1.1
 Section: libs
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Breaks: libiddawc0.9 (<< 0.9.8-2)
+Replaces: libiddawc0.9 (<< 0.9.8-2)
 Description: OAuth2 and OIDC client library
  Handles the OAuth2 and OpenID Connect authentication process flow from the
  client side.
@@ -38,7 +41,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libiddawc0.9 (= ${binary:Version}), ${misc:Depends}
+Depends: libiddawc1.1 (= ${binary:Version}), ${misc:Depends}
        , liborcania-dev
        , libyder-dev
        , libulfius-dev
@@ -55,3 +58,20 @@
   - Validates response values
  .
  This package contains the development files.
+
+Package: idwcc
+Architecture: any
+Depends: ${shlibs:Depends}
+       , ${misc:Depends}
+       , libiddawc1.1 (= ${binary:Version})
+       , fonts-fork-awesome
+       , libjs-jquery
+       , libjs-bootstrap4
+       , libjs-popper.js
+Description: Client for OAuth2/OIDC AS configuration validation
+ Provides a web application to be used as an OpenID Connect or OAuth2
+ client.
+ .
+ Supports PKCE, token introspection, revocation, client registration,
+ DPoP, Rich Authorization Request, Pushed Authorization Request,
+ JWT Access tokens, encrypted tokens, requests and responses.

=== debian/rules ===
--- 
+++ 
@@ -27,6 +27,7 @@
 
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 override_dh_auto_test:
+	cd test && ./cert/create-cert.sh && cp -R cert/ ../build/
 	cd build && $(MAKE) test -j1
 endif

=== debian/watch ===
version=4

# https://github.com/babelouest/iddawc
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%iddawc-$1.tar.gz%" \
   https://github.com/babelouest/iddawc/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
